(function (TypeFlagsAsString) {
    TypeFlagsAsString[TypeFlagsAsString["Any"] = 'Any'] = "Any";
    TypeFlagsAsString[TypeFlagsAsString["String"] = 'String'] = "String";
    TypeFlagsAsString[TypeFlagsAsString["Number"] = 'Number'] = "Number";
    TypeFlagsAsString[TypeFlagsAsString["Boolean"] = 'Boolean'] = "Boolean";
    TypeFlagsAsString[TypeFlagsAsString["Void"] = 'Void'] = "Void";
    TypeFlagsAsString[TypeFlagsAsString["Undefined"] = 'Undefined'] = "Undefined";
    TypeFlagsAsString[TypeFlagsAsString["Null"] = 'Null'] = "Null";
    TypeFlagsAsString[TypeFlagsAsString["Enum"] = 'Enum'] = "Enum";
    TypeFlagsAsString[TypeFlagsAsString["StringLiteral"] = 'StringLiteral'] = "StringLiteral";
    TypeFlagsAsString[TypeFlagsAsString["TypeParameter"] = 'TypeParameter'] = "TypeParameter";
    TypeFlagsAsString[TypeFlagsAsString["Class"] = 'Class'] = "Class";
    TypeFlagsAsString[TypeFlagsAsString["Interface"] = 'Interface'] = "Interface";
    TypeFlagsAsString[TypeFlagsAsString["Reference"] = 'Reference'] = "Reference";
    TypeFlagsAsString[TypeFlagsAsString["Tuple"] = 'Tuple'] = "Tuple";
    TypeFlagsAsString[TypeFlagsAsString["Union"] = 'Union'] = "Union";
    TypeFlagsAsString[TypeFlagsAsString["Anonymous"] = 'Anonymous'] = "Anonymous";
    TypeFlagsAsString[TypeFlagsAsString["Instantiated"] = 'Instantiated'] = "Instantiated";
    TypeFlagsAsString[TypeFlagsAsString["ObjectLiteral"] = 'ObjectLiteral'] = "ObjectLiteral";
    TypeFlagsAsString[TypeFlagsAsString["ESSymbol"] = 'ESSymbol'] = "ESSymbol";
    TypeFlagsAsString[TypeFlagsAsString["StringLike"] = 'StringLike'] = "StringLike";
    TypeFlagsAsString[TypeFlagsAsString["NumberLike"] = 'NumberLike'] = "NumberLike";
    TypeFlagsAsString[TypeFlagsAsString["ObjectType"] = 'ObjectType'] = "ObjectType";
})(exports.TypeFlagsAsString || (exports.TypeFlagsAsString = {}));
var TypeFlagsAsString = exports.TypeFlagsAsString;
function convertTypeFlags(typeFlags) {
    var result = [];
    if (typeFlags & 1) {
        result.push(TypeFlagsAsString.Any);
    }
    if (typeFlags & 2) {
        result.push(TypeFlagsAsString.String);
    }
    if (typeFlags & 4) {
        result.push(TypeFlagsAsString.Number);
    }
    if (typeFlags & 8) {
        result.push(TypeFlagsAsString.Boolean);
    }
    if (typeFlags & 16) {
        result.push(TypeFlagsAsString.Void);
    }
    if (typeFlags & 32) {
        result.push(TypeFlagsAsString.Undefined);
    }
    if (typeFlags & 64) {
        result.push(TypeFlagsAsString.Null);
    }
    if (typeFlags & 128) {
        result.push(TypeFlagsAsString.Enum);
    }
    if (typeFlags & 256) {
        result.push(TypeFlagsAsString.StringLiteral);
    }
    if (typeFlags & 512) {
        result.push(TypeFlagsAsString.TypeParameter);
    }
    if (typeFlags & 1024) {
        result.push(TypeFlagsAsString.Class);
    }
    if (typeFlags & 2048) {
        result.push(TypeFlagsAsString.Interface);
    }
    if (typeFlags & 4096) {
        result.push(TypeFlagsAsString.Reference);
    }
    if (typeFlags & 8192) {
        result.push(TypeFlagsAsString.Tuple);
    }
    if (typeFlags & 16384) {
        result.push(TypeFlagsAsString.Union);
    }
    if (typeFlags & 32768) {
        result.push(TypeFlagsAsString.Anonymous);
    }
    if (typeFlags & 65536) {
        result.push(TypeFlagsAsString.Instantiated);
    }
    if (typeFlags & 262144) {
        result.push(TypeFlagsAsString.ObjectLiteral);
    }
    if (typeFlags & 2097152) {
        result.push(TypeFlagsAsString.ESSymbol);
    }
    if (typeFlags & 258) {
        result.push(TypeFlagsAsString.StringLike);
    }
    if (typeFlags & 132) {
        result.push(TypeFlagsAsString.NumberLike);
    }
    if (typeFlags & 48128) {
        result.push(TypeFlagsAsString.ObjectType);
    }
    return result;
}
exports.convertTypeFlags = convertTypeFlags;
(function (SymbolFlagsAsString) {
    SymbolFlagsAsString[SymbolFlagsAsString["None"] = 'None'] = "None";
    SymbolFlagsAsString[SymbolFlagsAsString["FunctionScopedVariable"] = 'FunctionScopedVariable'] = "FunctionScopedVariable";
    SymbolFlagsAsString[SymbolFlagsAsString["BlockScopedVariable"] = 'BlockScopedVariable'] = "BlockScopedVariable";
    SymbolFlagsAsString[SymbolFlagsAsString["Property"] = 'Property'] = "Property";
    SymbolFlagsAsString[SymbolFlagsAsString["EnumMember"] = 'EnumMember'] = "EnumMember";
    SymbolFlagsAsString[SymbolFlagsAsString["Function"] = 'Function'] = "Function";
    SymbolFlagsAsString[SymbolFlagsAsString["Class"] = 'Class'] = "Class";
    SymbolFlagsAsString[SymbolFlagsAsString["Interface"] = 'Interface'] = "Interface";
    SymbolFlagsAsString[SymbolFlagsAsString["ConstEnum"] = 'ConstEnum'] = "ConstEnum";
    SymbolFlagsAsString[SymbolFlagsAsString["RegularEnum"] = 'RegularEnum'] = "RegularEnum";
    SymbolFlagsAsString[SymbolFlagsAsString["ValueModule"] = 'ValueModule'] = "ValueModule";
    SymbolFlagsAsString[SymbolFlagsAsString["NamespaceModule"] = 'NamespaceModule'] = "NamespaceModule";
    SymbolFlagsAsString[SymbolFlagsAsString["TypeLiteral"] = 'TypeLiteral'] = "TypeLiteral";
    SymbolFlagsAsString[SymbolFlagsAsString["ObjectLiteral"] = 'ObjectLiteral'] = "ObjectLiteral";
    SymbolFlagsAsString[SymbolFlagsAsString["Method"] = 'Method'] = "Method";
    SymbolFlagsAsString[SymbolFlagsAsString["Constructor"] = 'Constructor'] = "Constructor";
    SymbolFlagsAsString[SymbolFlagsAsString["GetAccessor"] = 'GetAccessor'] = "GetAccessor";
    SymbolFlagsAsString[SymbolFlagsAsString["SetAccessor"] = 'SetAccessor'] = "SetAccessor";
    SymbolFlagsAsString[SymbolFlagsAsString["Signature"] = 'Signature'] = "Signature";
    SymbolFlagsAsString[SymbolFlagsAsString["TypeParameter"] = 'TypeParameter'] = "TypeParameter";
    SymbolFlagsAsString[SymbolFlagsAsString["TypeAlias"] = 'TypeAlias'] = "TypeAlias";
    SymbolFlagsAsString[SymbolFlagsAsString["ExportValue"] = 'ExportValue'] = "ExportValue";
    SymbolFlagsAsString[SymbolFlagsAsString["ExportType"] = 'ExportType'] = "ExportType";
    SymbolFlagsAsString[SymbolFlagsAsString["ExportNamespace"] = 'ExportNamespace'] = "ExportNamespace";
    SymbolFlagsAsString[SymbolFlagsAsString["Alias"] = 'Alias'] = "Alias";
    SymbolFlagsAsString[SymbolFlagsAsString["Instantiated"] = 'Instantiated'] = "Instantiated";
    SymbolFlagsAsString[SymbolFlagsAsString["Merged"] = 'Merged'] = "Merged";
    SymbolFlagsAsString[SymbolFlagsAsString["Transient"] = 'Transient'] = "Transient";
    SymbolFlagsAsString[SymbolFlagsAsString["Prototype"] = 'Prototype'] = "Prototype";
    SymbolFlagsAsString[SymbolFlagsAsString["UnionProperty"] = 'UnionProperty'] = "UnionProperty";
    SymbolFlagsAsString[SymbolFlagsAsString["Optional"] = 'Optional'] = "Optional";
    SymbolFlagsAsString[SymbolFlagsAsString["ExportStar"] = 'ExportStar'] = "ExportStar";
    SymbolFlagsAsString[SymbolFlagsAsString["Enum"] = 'Enum'] = "Enum";
    SymbolFlagsAsString[SymbolFlagsAsString["Variable"] = 'Variable'] = "Variable";
    SymbolFlagsAsString[SymbolFlagsAsString["Value"] = 'Value'] = "Value";
    SymbolFlagsAsString[SymbolFlagsAsString["Type"] = 'Type'] = "Type";
    SymbolFlagsAsString[SymbolFlagsAsString["Namespace"] = 'Namespace'] = "Namespace";
    SymbolFlagsAsString[SymbolFlagsAsString["Module"] = 'Module'] = "Module";
    SymbolFlagsAsString[SymbolFlagsAsString["Accessor"] = 'Accessor'] = "Accessor";
    SymbolFlagsAsString[SymbolFlagsAsString["FunctionScopedVariableExcludes"] = 'FunctionScopedVariableExcludes'] = "FunctionScopedVariableExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["BlockScopedVariableExcludes"] = 'BlockScopedVariableExcludes'] = "BlockScopedVariableExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["ParameterExcludes"] = 'ParameterExcludes'] = "ParameterExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["PropertyExcludes"] = 'PropertyExcludes'] = "PropertyExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["EnumMemberExcludes"] = 'EnumMemberExcludes'] = "EnumMemberExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["FunctionExcludes"] = 'FunctionExcludes'] = "FunctionExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["ClassExcludes"] = 'ClassExcludes'] = "ClassExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["InterfaceExcludes"] = 'InterfaceExcludes'] = "InterfaceExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["RegularEnumExcludes"] = 'RegularEnumExcludes'] = "RegularEnumExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["ConstEnumExcludes"] = 'ConstEnumExcludes'] = "ConstEnumExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["ValueModuleExcludes"] = 'ValueModuleExcludes'] = "ValueModuleExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["NamespaceModuleExcludes"] = 'NamespaceModuleExcludes'] = "NamespaceModuleExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["MethodExcludes"] = 'MethodExcludes'] = "MethodExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["GetAccessorExcludes"] = 'GetAccessorExcludes'] = "GetAccessorExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["SetAccessorExcludes"] = 'SetAccessorExcludes'] = "SetAccessorExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["TypeParameterExcludes"] = 'TypeParameterExcludes'] = "TypeParameterExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["TypeAliasExcludes"] = 'TypeAliasExcludes'] = "TypeAliasExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["AliasExcludes"] = 'AliasExcludes'] = "AliasExcludes";
    SymbolFlagsAsString[SymbolFlagsAsString["ModuleMember"] = 'ModuleMember'] = "ModuleMember";
    SymbolFlagsAsString[SymbolFlagsAsString["ExportHasLocal"] = 'ExportHasLocal'] = "ExportHasLocal";
    SymbolFlagsAsString[SymbolFlagsAsString["HasExports"] = 'HasExports'] = "HasExports";
    SymbolFlagsAsString[SymbolFlagsAsString["HasMembers"] = 'HasMembers'] = "HasMembers";
    SymbolFlagsAsString[SymbolFlagsAsString["BlockScoped"] = 'BlockScoped'] = "BlockScoped";
    SymbolFlagsAsString[SymbolFlagsAsString["PropertyOrAccessor"] = 'PropertyOrAccessor'] = "PropertyOrAccessor";
    SymbolFlagsAsString[SymbolFlagsAsString["Export"] = 'Export'] = "Export";
})(exports.SymbolFlagsAsString || (exports.SymbolFlagsAsString = {}));
var SymbolFlagsAsString = exports.SymbolFlagsAsString;
function convertSymbolFlags(symbolFlags) {
    var result = [];
    if (symbolFlags & 0) {
        result.push(SymbolFlagsAsString.None);
    }
    if (symbolFlags & 1) {
        result.push(SymbolFlagsAsString.FunctionScopedVariable);
    }
    if (symbolFlags & 2) {
        result.push(SymbolFlagsAsString.BlockScopedVariable);
    }
    if (symbolFlags & 4) {
        result.push(SymbolFlagsAsString.Property);
    }
    if (symbolFlags & 8) {
        result.push(SymbolFlagsAsString.EnumMember);
    }
    if (symbolFlags & 16) {
        result.push(SymbolFlagsAsString.Function);
    }
    if (symbolFlags & 32) {
        result.push(SymbolFlagsAsString.Class);
    }
    if (symbolFlags & 64) {
        result.push(SymbolFlagsAsString.Interface);
    }
    if (symbolFlags & 128) {
        result.push(SymbolFlagsAsString.ConstEnum);
    }
    if (symbolFlags & 256) {
        result.push(SymbolFlagsAsString.RegularEnum);
    }
    if (symbolFlags & 512) {
        result.push(SymbolFlagsAsString.ValueModule);
    }
    if (symbolFlags & 1024) {
        result.push(SymbolFlagsAsString.NamespaceModule);
    }
    if (symbolFlags & 2048) {
        result.push(SymbolFlagsAsString.TypeLiteral);
    }
    if (symbolFlags & 4096) {
        result.push(SymbolFlagsAsString.ObjectLiteral);
    }
    if (symbolFlags & 8192) {
        result.push(SymbolFlagsAsString.Method);
    }
    if (symbolFlags & 16384) {
        result.push(SymbolFlagsAsString.Constructor);
    }
    if (symbolFlags & 32768) {
        result.push(SymbolFlagsAsString.GetAccessor);
    }
    if (symbolFlags & 65536) {
        result.push(SymbolFlagsAsString.SetAccessor);
    }
    if (symbolFlags & 131072) {
        result.push(SymbolFlagsAsString.Signature);
    }
    if (symbolFlags & 262144) {
        result.push(SymbolFlagsAsString.TypeParameter);
    }
    if (symbolFlags & 524288) {
        result.push(SymbolFlagsAsString.TypeAlias);
    }
    if (symbolFlags & 1048576) {
        result.push(SymbolFlagsAsString.ExportValue);
    }
    if (symbolFlags & 2097152) {
        result.push(SymbolFlagsAsString.ExportType);
    }
    if (symbolFlags & 4194304) {
        result.push(SymbolFlagsAsString.ExportNamespace);
    }
    if (symbolFlags & 8388608) {
        result.push(SymbolFlagsAsString.Alias);
    }
    if (symbolFlags & 16777216) {
        result.push(SymbolFlagsAsString.Instantiated);
    }
    if (symbolFlags & 33554432) {
        result.push(SymbolFlagsAsString.Merged);
    }
    if (symbolFlags & 67108864) {
        result.push(SymbolFlagsAsString.Transient);
    }
    if (symbolFlags & 134217728) {
        result.push(SymbolFlagsAsString.Prototype);
    }
    if (symbolFlags & 268435456) {
        result.push(SymbolFlagsAsString.UnionProperty);
    }
    if (symbolFlags & 536870912) {
        result.push(SymbolFlagsAsString.Optional);
    }
    if (symbolFlags & 1073741824) {
        result.push(SymbolFlagsAsString.ExportStar);
    }
    if (symbolFlags & 384) {
        result.push(SymbolFlagsAsString.Enum);
    }
    if (symbolFlags & 3) {
        result.push(SymbolFlagsAsString.Variable);
    }
    if (symbolFlags & 107455) {
        result.push(SymbolFlagsAsString.Value);
    }
    if (symbolFlags & 793056) {
        result.push(SymbolFlagsAsString.Type);
    }
    if (symbolFlags & 1536) {
        result.push(SymbolFlagsAsString.Namespace);
    }
    if (symbolFlags & 1536) {
        result.push(SymbolFlagsAsString.Module);
    }
    if (symbolFlags & 98304) {
        result.push(SymbolFlagsAsString.Accessor);
    }
    if (symbolFlags & 107454) {
        result.push(SymbolFlagsAsString.FunctionScopedVariableExcludes);
    }
    if (symbolFlags & 107455) {
        result.push(SymbolFlagsAsString.BlockScopedVariableExcludes);
    }
    if (symbolFlags & 107455) {
        result.push(SymbolFlagsAsString.ParameterExcludes);
    }
    if (symbolFlags & 107455) {
        result.push(SymbolFlagsAsString.PropertyExcludes);
    }
    if (symbolFlags & 107455) {
        result.push(SymbolFlagsAsString.EnumMemberExcludes);
    }
    if (symbolFlags & 106927) {
        result.push(SymbolFlagsAsString.FunctionExcludes);
    }
    if (symbolFlags & 899583) {
        result.push(SymbolFlagsAsString.ClassExcludes);
    }
    if (symbolFlags & 792992) {
        result.push(SymbolFlagsAsString.InterfaceExcludes);
    }
    if (symbolFlags & 899327) {
        result.push(SymbolFlagsAsString.RegularEnumExcludes);
    }
    if (symbolFlags & 899967) {
        result.push(SymbolFlagsAsString.ConstEnumExcludes);
    }
    if (symbolFlags & 106639) {
        result.push(SymbolFlagsAsString.ValueModuleExcludes);
    }
    if (symbolFlags & 0) {
        result.push(SymbolFlagsAsString.NamespaceModuleExcludes);
    }
    if (symbolFlags & 99263) {
        result.push(SymbolFlagsAsString.MethodExcludes);
    }
    if (symbolFlags & 41919) {
        result.push(SymbolFlagsAsString.GetAccessorExcludes);
    }
    if (symbolFlags & 74687) {
        result.push(SymbolFlagsAsString.SetAccessorExcludes);
    }
    if (symbolFlags & 530912) {
        result.push(SymbolFlagsAsString.TypeParameterExcludes);
    }
    if (symbolFlags & 793056) {
        result.push(SymbolFlagsAsString.TypeAliasExcludes);
    }
    if (symbolFlags & 8388608) {
        result.push(SymbolFlagsAsString.AliasExcludes);
    }
    if (symbolFlags & 8914931) {
        result.push(SymbolFlagsAsString.ModuleMember);
    }
    if (symbolFlags & 944) {
        result.push(SymbolFlagsAsString.ExportHasLocal);
    }
    if (symbolFlags & 1952) {
        result.push(SymbolFlagsAsString.HasExports);
    }
    if (symbolFlags & 6240) {
        result.push(SymbolFlagsAsString.HasMembers);
    }
    if (symbolFlags & 418) {
        result.push(SymbolFlagsAsString.BlockScoped);
    }
    if (symbolFlags & 98308) {
        result.push(SymbolFlagsAsString.PropertyOrAccessor);
    }
    if (symbolFlags & 7340032) {
        result.push(SymbolFlagsAsString.Export);
    }
    return result;
}
exports.convertSymbolFlags = convertSymbolFlags;
//# sourceMappingURL=flags.js.map